//
//  SessionLogin.swift
//  Sailassist
//
//  Created by 三浦薫巳 on 2023/10/26.
//

import Foundation
import SwiftUI

class SessionLogin : ObservableObject {
    @Published var status = false
    // シングルトン宣言
    static let OnlyOne = SessionLogin()

    private var serverSession = ServerSession()
    private var Calling : Bool = false      // 通信中

    /**
     * ログイン
     *  - Parameters:
     *    - login: ログイン情報
     */
    func RequestLogin(_ login : ReqLogin, completion: @escaping ((Result<Data, APIError>)) -> Void) {
        print(debug: "calld")
        if Calling {
            return
        }
        Calling = true

        // リクエストURLの組み立て
        let url_string : String = HttpRequestType.RegisterLogin.rawValue
        guard let req_url = URL(string : url_string) else {
            Calling = false
            return
        }

        if let postdata = serverSession.toJSON(login) {
            serverSession.postJson(req_url, postdata, completion: completion)
        }
        else {
            Calling = false
            return
        }
    }
}
